<template>
  <AmsTwoPanels>
    <template #left>
      <AmsOperationalPanelTables :content-options="CONTENT_OPTIONS" />
    </template>
    <template #right>
      <AmsOperationalPanelMap />
    </template>
  </AmsTwoPanels>
</template>

<script lang="ts">
import {
  defineComponent,
  inject,
  onMounted,
  provide,
} from "@nuxtjs/composition-api";

// Libraries
import throttle from "lodash/throttle";

// Global config
// @ts-ignore
import resolveConfig from "tailwindcss/resolveConfig";
import tailwindConfig from "~/tailwind.config.js";

// Composables
import useScansPrep from "~/components/Views/Operational/composables/scans-prep";

const $tailwind = resolveConfig(tailwindConfig);
const breakpoint = Number($tailwind.theme.screens.x2l.slice(0, $tailwind.theme.screens.x2l.indexOf("px")));

let screenBelowBreakpoint = true;

export default defineComponent({
  components: {
    AmsTwoPanels: () => import("~/components/Layout/TwoPanels.vue"),
    AmsOperationalPanelTables: () => import("~/components/Views/Operational/OperationalPanelTables.vue"),
    AmsOperationalPanelMap: () => import("~/components/Views/Operational/OperationalPanelMap.vue"),
  },

  setup () {
    const store: any = inject("store");
    const {
      fetchDistricts,
      fetchDaysWithScans,
      fetchScans,
      tableGroups,
    } = useScansPrep();

    const CONTENT_OPTIONS = {
      title: "scan_results_per_day",
      enableNav: false,
      enableViewOptions: true,
    };

    provide("tableGroups", tableGroups);

    /**
     * Enable or disable toggling the right panel with the map depending on the viewport width.
     */
    function toggleMapSwitch () {
      screenBelowBreakpoint = window.innerWidth < breakpoint;
      store.enableMapSwitch(true && screenBelowBreakpoint);

      if (!screenBelowBreakpoint) {
        store.switchRightPanel(true);
      }
    }

    /**
     * Initialize the data for the view.
     */
    function initViewData () {
      fetchDistricts();
      fetchDaysWithScans();
      fetchScans();
    }

    onMounted(() => {
      window.addEventListener("resize", throttle(toggleMapSwitch, 1000));

      toggleMapSwitch();
      initViewData();
    });

    return {
      CONTENT_OPTIONS,
    };
  },
});
</script>
